#include "iostream"
#include "Coordenades.h"


#ifndef ROBOT_H
#define ROBOT_H

using namespace std;


#define BAUDRATE 9600
#define PARITAT EVENPARITY
#define BYTESIZE 7
#define STOPBITS TWOSTOPBITS
#define TIMEOUT 1000


class Robot
{
	//Variables
	HANDLE serie;			//punter a l'objecte COM1
	DCB dcb;				//estructura pels parametres de comunicacio
	COMMTIMEOUTS timeout;	//temps maxim d'espera per una resposta
	DWORD bytesEscrits;		//quantitat de bytes escrits pel port
	DWORD bytesLlegits;		//quantitat de bytes llegits pel port
	char lectura[50];		//missatge llegit
	char posInici[50];		//vector amb les coord. de la posici de referncia
	char recollirPeca[42];	//vector amb les coord. de la posici de recollida
	int ret;				//valor de retorn de la funci


public:
	//Constructor
	Robot();
	//Destructor
	~Robot();

	void obrirPortSerie();
	void tancarPortSerie();
	void inicialitzar();
	void modificarSortida(int sortida, int valor);
	int llegirEntrada(int entrada);
	void disponible();
	void enviarInstruccio(char instruccio[50]);
	void obtenirCoordenades(int num, Coordenades &coord);
	void moureSobrePeca(Coordenades coord);
	
};

#endif