#include "ifc.h"
#include "iostream"
#include "windowsx.h"	//Per les funcions GlobalAllocPtr i GlobalFreePtr
#include "cmath"		//Per sqrt
#include "NSII.h"
#include "Coordenades.h"
//cvBlobsLib
#include "C:\cvBlobsLib\blob.h" 
#include "C:\cvBlobsLib\blobresult.h"
//OpenCV
#include "cxcore.h"
#include "cv.h"
#include "highgui.h"
#include "cvaux.h"
//Otsu
#include "stdio.h"
#include "string.h"


#ifndef SISTEMAVISIO_H
#define SISTEMAVISIO_H

using namespace std;


#define CANTONADES_TAULER_X 13
#define CANTONADES_TAULER_Y 9
#define TAMANY_QUADRAT 45
#define Abs(x) ((x<0)?-(x):x)


class SistemaVisio
{
	//Variables 
	PCICapMod m_iCap;		//objecte de captura d'imatge
	CICamera *m_cam;		//objecte camera
	CAM_ATTR camAttr;		//atributs de la camera
	int m_iActiveBoard ;	//n de placa activa
	bool calibrada;			//indica si la camera s'ha calibrat o no
	CvMat *param_intrinsecs;//parametres intrinsecs de la cmera obtinguts de la calibracio
	CvMat *coef_distorsio;	//coeficient de distorsi de la cmera obtinguts de la calibracio
	int ampladaImatge;		//pixels d'amplada de la imatge
	int alcadaImatge;		//pixels d'alada de la imatge
	BYTE *m_imgBuf;			//espai de memoria destinat a la captura
	BYTE *m_imgBufCor;		//espai de memoria destinat a la captura corretgida
	BYTE *m_imgBufCorBin;	//espai de memoria destinat a la captura binaritzada corretgida
	CImgFile *m_imgFile;	//fitxer d'imatge

	
public:
	//Constructor
	SistemaVisio();
	//Destructor
	~SistemaVisio();
	//Funcions
	void inicialitzarCamera();
	void calibrarCamera();
	void capturarImatge(bool corregir);
	void corregirImatge();	
	void deteccioBlobsAR(Coordenades &coord);
	void deteccioBlob(Coordenades &coord);
	void InitCorners3D(CvMat *Corners3D, CvSize ChessBoardSize, int NImages, float SquareSize);
	
	//Algoritme Otsu per Ryan Dibble
	int otsu (unsigned char *image, int rows, int cols, int x0, int y0, int dx, int dy, int vvv);
};

#endif